#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		ip6name		ip6tables
%define		sum256		d87303d55ef8c92bcad4dd3f978b26d272013642b029425775f5bad1009fe7b2
#-----------------------------------------------------------------------------
Name		:	iptables
Version		:	1.8.11
Release		:	17.2.0.rel%{?dist}
Summary		:	Tools for managing Linux kernel packet filtering capabilities
Group		:	System Environment/Base

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+
URL		:	http://www.netfilter.org/projects/iptables

Source0		:	%{name}-%{version}.tar.xz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	coreutils
BuildRequires	:	libnfnetlink-devel
BuildRequires	:	libnetfilter_acct-devel
BuildRequires	:	libnetfilter_conntrack-devel
BuildRequires	:	libnetfilter_cthelper-devel
BuildRequires	:	libnetfilter_log-devel
BuildRequires	:	libnftnl-devel

Requires	:	ulogd
Requires	:	libnetfilter_acct
Requires	:	libnetfilter_conntrack
Requires	:	libnetfilter_cthelper
Requires	:	libnetfilter_log

Requires(post)	:	chkconfig
Requires(post)	:	coreutils
Requires(post)	:	lfs-bootscripts
Requires(post)	:	inetutils
Requires(post)	:	sed
Requires(post)	:	sipcalc
#-----------------------------------------------------------------------------
%description
iptables is the userspace command line program used to configure the Linux 2.4.x
and later packet filtering ruleset. It is targeted towards system administrators.

Since Network Address Translation is also configured from the packet filter ruleset,
iptables is used for this, too.

The iptables package also includes ip6tables. ip6tables is used for configuring the
IPv6 packet filter. 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING INSTALL
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{ip6name}
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/sysconfig/%{name}-config
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/sysconfig/%{ip6name}-config
%{_sysconfdir}/%{name}/ethertypes
%{_sbindir}/*
%{_bindir}/%{name}-xml
%{_libdir}/libip4tc.so.2*
%{_libdir}/libip6tc.so.2*
%{_libdir}/libipq.so.0*
%{_libdir}/libxtables*.so.12*
%{_libdir}/xtables/*.so
%{_datadir}/xtables/pf.os
%{_datadir}/xtables/%{name}.xslt
%{_mandir}/man1/*.1.gz
%{_mandir}/man3/*.3.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{ip6name}
  %{_sbindir}/chkconfig --del %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%package		config

Summary		:	iptables config file

Requires	:	%{name}		=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description		config
This package include ONLY the default iptable config file

#-----------------------------------------------------------------------------
%files			config
%defattr(-,root,root,-)
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/sysconfig/%{ip6name}

%post			config
if [ "$1" = 1 ]; then
  NET=`/usr/sbin/route -n				\
		| grep ^0.0.0.0 			\
		| tr -s ' '				\
		| cut -d ' ' -f2			\
		| cut -d '.' -f1-3`

  ENTRY=`/usr/sbin/ifconfig 2>/dev/null			\
		| grep 'inet'				\
		| grep ${NET}				\
		| head -1`

  #adjusting iptable protection to local network
  HOSTIP=`echo ${ENTRY}					\
		| cut -d ' ' -f2`

  CURMASK=`echo -n ${ENTRY}				\
		| cut -d ' ' -f4 			\
		| cut -d '.' -f1-3`

  CURMASK=${CURMASK}".0"
  if [ -n "${CURMASK}" ] ; then
    NETIP=`sipcalc ${HOSTIP} ${CURMASK}			\
	   | grep "Network address"			\
	   | head -1					\
	   | cut -d '-' -f2				\
	   | tr -d ' '`
    fi
  if [ -z "$NETIP" -o -z "$CURMASK"  ] ; then
    NETIP="0.0.0.0"
    CURMASK="0.0.0.0"
    fi
  sed -i					\
    -e "s/@@NETIP@@/${NETIP}/"			\
    -e "s/@@CURMASK@@/${CURMASK}/"		\
    %{_sysconfdir}/sysconfig/%{name}
  fi
%{_sbindir}/chkconfig --add %{name}
%{_sbindir}/chkconfig %{name} on
%{_sbindir}/chkconfig --add %{ip6name}
%{_sbindir}/chkconfig %{ip6name} on
%{_sysconfdir}/rc.d/init.d/%{name} condrestart		> /dev/null 2>&1 || :
%{_sysconfdir}/rc.d/init.d/%{ip6name} condrestart	> /dev/null 2>&1 || :

#=============================================================================
%package		devel

Summary		:	iptables development headers and pkgconfig files

Requires	:	%{name}		=  %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/*.h
%{_includedir}/%{name}/*.h
%{_includedir}/libiptc/*.h
%{_libdir}/libip4tc.so
%{_libdir}/libip6tc.so
%{_libdir}/libipq.so
%{_libdir}/libxtables*.so
%{_libdir}/pkgconfig/libip4tc.pc
%{_libdir}/pkgconfig/libip6tc.pc
%{_libdir}/pkgconfig/libiptc.pc
%{_libdir}/pkgconfig/libipq.pc
%{_libdir}/pkgconfig/xtables.pc

#=============================================================================
%prep
echo %{sum256} %{SOURCE0} | sha256sum --check --status

%setup -q
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

./autogen.sh
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}/%{name}		\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-libipq					\
	--enable-connlabel				\
	--enable-nftables				\
	--with-xtlibdir=%{_libdir}/xtables		\
	
#	--with-kernel=%{_prefix}			\
#	--with-kbuild=%{_prefix}			\
#	--with-ksource=%{_prefix}			\
#	--enable-devel					\

sed -i							\
 -e 's/ -shared / -Wl,-O1,--as-needed\0/g'		\
 libtool

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install

#installing iptables starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
for xec in %{name} %{ip6name}
  do
  %{__cp} 						\
	%{name}-ok_addon/$xec				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/
  done

#installing iptables configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sysconfig
for xec in %{name} %{ip6name}
  do
  %{__cp} 						\
	%{name}-ok_addon/$xec-sysconfig			\
	%{buildroot}%{_sysconfdir}/sysconfig/$xec
  %{__cp}						\
	%{name}-ok_addon/$xec-config			\
	 %{buildroot}%{_sysconfdir}/sysconfig
  done

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

install -m 644 include/ip*tables.h %{buildroot}%{_includedir}/
install -d -m 755 %{buildroot}%{_includedir}/%{name}
install -m 644 include/iptables/internal.h %{buildroot}%{_includedir}/%{name}/

#fix absolute symlink
%{__rm} -f %{buildroot}%{_bindir}/%{name}-xml
%{__ln_s}						\
	../sbin/xtables-legacy-multi			\
	%{buildroot}%{_bindir}/%{name}-xml
#-----------------------------------------------------------------------------
%changelog
